/*
Copyright (C) 1995 M. A. S. Elmohamed,
Northeast Parallel Architectures Center, Syracuse University.
saleh@npac.syr.edu
*/

/*... testing stuff removed  10/22/99.  -Saleh */

#include <stdio.h>
#include "misc.h"
#include "config.h"
#include "pi.h"
#include "st.h"

st_t st_create(char *name, ft_t ft)
{
  st_t st = (st_t) xcalloc(1,sizeof(st_s));
  st->ft = ft;
  st->name = name;
  return(st);
}

void st_destroy(st_t st)
{
  xfree((char *)st);
}

sta_t sta_create(void)
{
  sta_t sta = (sta_t)xcalloc(1,sizeof(sta_s));
  return(sta);
}

void sta_destroy(sta_t sta)
{
  register int i;
  for (i = 0; i < sta->nst; i++)
    st_destroy(sta->st[i]);
  xfree((char *)sta);
}

void sta_time_sort(sta_t sta)
{
  int done, i, stalen = sta->nst;
  st_t *st = sta->st, tst;
  
  done = 0;
  while (done == 0) {
    done = 1;
    for (i = 0; i < stalen - 1; i++) {
      if (st[i]->ft->bt > st[i+1]->ft->bt) {
	tst = st[i];
	st[i] = st[i+1];
	st[i+1] = tst;
	done = 0;
      }
    }
  }
}

st_t sta_add(sta_t sta, char *name, ft_t ft)
{
  st_t st = (st_t)0;

  if (sta != (sta_t)0) {
    if (sta->nst >= sta->nst_limit) { /* need more array space */
      if (sta->st == (st_t *)0)
	sta->st = (st_t *)
	  xmalloc((sta->nst_limit + STA_INCREMENT) * sizeof(st_t));
      else {
	sta->st = (st_t *)
	  xrealloc((char *)sta->st,
		   (sta->nst_limit + STA_INCREMENT) * sizeof(st_t));
	}
      sta->nst_limit += STA_INCREMENT;
    }
    st = sta->st[sta->nst] = st_create(name, ft);
    sta->nst++;
  }
    
  return(st);
}

